Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3050)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3051)
@@ -865,487 +859,439 @@
        var_exchange_real = 0.0_wp
 
-       DO  ii = 0, io_blocks-1
-          IF ( ii == io_group )  THEN
 #if defined ( __netcdf )
 !
-!--          Open file in read-only mode
-             CALL open_read_file( TRIM( input_file_static ) //                 &
-                                  TRIM( coupling_char ) , id_surf )
-
-!
-!--          Inquire all variable names.
-!--          This will be used to check whether an optional input variable exist
-!--          or not.
-             CALL inquire_num_variables( id_surf, num_vars )
-
-             ALLOCATE( var_names(1:num_vars) )
-             CALL inquire_variable_names( id_surf, var_names )
-
-!
-!--          Read vegetation type and required attributes
-             IF ( check_existence( var_names, 'vegetation_type' ) )  THEN
-                vegetation_type_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    vegetation_type_f%fill,                    &
-                                    .FALSE., 'vegetation_type' )
-!
-!--             PE-wise reading of 2D vegetation type.
-                ALLOCATE ( vegetation_type_f%var(nys:nyn,nxl:nxr)  )
-
-                DO  i = nxl, nxr
-                   CALL get_variable( id_surf, 'vegetation_type',              &
-                                      i, vegetation_type_f%var(:,i) )
-                ENDDO
-             ELSE
-                vegetation_type_f%from_file = .FALSE.
-             ENDIF
-
-!
-!--          Read soil type and required attributes
-             IF ( check_existence( var_names, 'soil_type' ) )  THEN
-                   soil_type_f%from_file = .TRUE.
-!
-!--             Note, lod is currently not on file; skip for the moment
-!                 CALL get_attribute( id_surf, char_lod,                       &
-!                                            soil_type_f%lod,                  &
-!                                            .FALSE., 'soil_type' )
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    soil_type_f%fill,                          &
-                                    .FALSE., 'soil_type' )
-
-                IF ( soil_type_f%lod == 1 )  THEN
-!
-!--                PE-wise reading of 2D soil type.
-                   ALLOCATE ( soil_type_f%var_2d(nys:nyn,nxl:nxr)  )
-                   DO  i = nxl, nxr
-                      CALL get_variable( id_surf, 'soil_type',                 &
-                                         i, soil_type_f%var_2d(:,i) )
-                   ENDDO
-                ELSEIF ( soil_type_f%lod == 2 )  THEN
-!
-!--                Obtain number of soil layers from file.
-                   CALL get_dimension_length( id_surf, nz_soil, 'zsoil' )
-!
-!--                PE-wise reading of 3D soil type.
-                   ALLOCATE ( soil_type_f%var_3d(0:nz_soil,nys:nyn,nxl:nxr) )
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         CALL get_variable( id_surf, 'soil_type', i, j,        &
-                                            soil_type_f%var_3d(:,j,i) )
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ELSE
-                soil_type_f%from_file = .FALSE.
-             ENDIF
-
-!
-!--          Read pavement type and required attributes
-             IF ( check_existence( var_names, 'pavement_type' ) )  THEN
-                pavement_type_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    pavement_type_f%fill, .FALSE.,             &
-                                    'pavement_type' )
-!
-!--             PE-wise reading of 2D pavement type.
-                ALLOCATE ( pavement_type_f%var(nys:nyn,nxl:nxr)  )
-                DO  i = nxl, nxr
-                   CALL get_variable( id_surf, 'pavement_type',                &
-                                      i, pavement_type_f%var(:,i) )
-                ENDDO
-             ELSE
-                pavement_type_f%from_file = .FALSE.
-             ENDIF
-
-!
-!--          Read water type and required attributes
-             IF ( check_existence( var_names, 'water_type' ) )  THEN
-                water_type_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill, water_type_f%fill,     &
-                                    .FALSE., 'water_type' )
-!
-!--             PE-wise reading of 2D water type.
-                ALLOCATE ( water_type_f%var(nys:nyn,nxl:nxr)  )
-                DO  i = nxl, nxr
-                   CALL get_variable( id_surf, 'water_type', i,                &
-                                      water_type_f%var(:,i) )
-                ENDDO
-             ELSE
-                water_type_f%from_file = .FALSE.
-             ENDIF
-!
-!--          Read surface fractions and related information
-             IF ( check_existence( var_names, 'surface_fraction' ) )  THEN
-                surface_fraction_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    surface_fraction_f%fill,                   &
-                                    .FALSE., 'surface_fraction' )
-!
-!--             Inquire number of surface fractions
-                CALL get_dimension_length( id_surf,                            &
-                                           surface_fraction_f%nf,              &
-                                           'nsurface_fraction' )
-!
-!--             Allocate dimension array and input array for surface fractions
-                ALLOCATE( surface_fraction_f%nfracs(0:surface_fraction_f%nf-1) )
-                ALLOCATE( surface_fraction_f%frac(0:surface_fraction_f%nf-1,   &
-                                                  nys:nyn,nxl:nxr) )
-!
-!--             Get dimension of surface fractions
-                CALL get_variable( id_surf, 'nsurface_fraction',               &
-                                   surface_fraction_f%nfracs )
-!
-!--             Read surface fractions
-                CALL get_variable( id_surf, 'surface_fraction',     &
-                                   nxl, nxr, nys, nyn,              &
-                                   surface_fraction_f%frac(:,nys:nyn, nxl:nxr))
-             ELSE
-                surface_fraction_f%from_file = .FALSE.
-             ENDIF
-!
-!--          Read building parameters and related information
-             IF ( check_existence( var_names, 'building_pars' ) )  THEN
-                building_pars_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    building_pars_f%fill,                      &
-                                    .FALSE., 'building_pars' )
-!
-!--             Inquire number of building parameters
-                CALL get_dimension_length( id_surf,                            &
-                                           building_pars_f%np,                 &
-                                           'nbuilding_pars' )
-!
-!--             Allocate dimension array and input array for building parameters
-                ALLOCATE( building_pars_f%pars(0:building_pars_f%np-1) )
-                ALLOCATE( building_pars_f%pars_xy(0:building_pars_f%np-1,      &
-                                                  nys:nyn,nxl:nxr) )
-!
-!--             Get dimension of building parameters
-                CALL get_variable( id_surf, 'nbuilding_pars',                  &
-                                   building_pars_f%pars )
-!
-!--             Read building_pars
-                CALL get_variable( id_surf, 'building_pars',                   &
-                                   nxl, nxr, nys, nyn,                         &
-                                   building_pars_f%pars_xy(:,nys:nyn, nxl:nxr) )
-             ELSE
-                building_pars_f%from_file = .FALSE.
-             ENDIF
-
-!
-!--          Read albedo type and required attributes
-             IF ( check_existence( var_names, 'albedo_type' ) )  THEN
-                albedo_type_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill, albedo_type_f%fill,    &
-                                    .FALSE.,  'albedo_type' )
-!
-!--             PE-wise reading of 2D water type.
-                ALLOCATE ( albedo_type_f%var(nys:nyn,nxl:nxr)  )
-                DO  i = nxl, nxr
-                   CALL get_variable( id_surf, 'albedo_type',                  &
-                                      i, albedo_type_f%var(:,i) )
-                ENDDO
-             ELSE
-                albedo_type_f%from_file = .FALSE.
-             ENDIF
-!
-!--          Read albedo parameters and related information
-             IF ( check_existence( var_names, 'albedo_pars' ) )  THEN
-                albedo_pars_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill, albedo_pars_f%fill,    &
-                                    .FALSE., 'albedo_pars' )
-!
-!--             Inquire number of albedo parameters
-                CALL get_dimension_length( id_surf, albedo_pars_f%np,          &
-                                           'nalbedo_pars' )
-!
-!--             Allocate dimension array and input array for albedo parameters
-                ALLOCATE( albedo_pars_f%pars(0:albedo_pars_f%np-1) )
-                ALLOCATE( albedo_pars_f%pars_xy(0:albedo_pars_f%np-1,          &
-                                                nys:nyn,nxl:nxr) )
-!
-!--             Get dimension of albedo parameters
-                CALL get_variable( id_surf, 'nalbedo_pars', albedo_pars_f%pars )
-
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      CALL get_variable( id_surf, 'albedo_pars', i, j,         &
-                                         albedo_pars_f%pars_xy(:,j,i) )
-                   ENDDO
-                ENDDO
-             ELSE
-                albedo_pars_f%from_file = .FALSE.
-             ENDIF
-
-!
-!--          Read pavement parameters and related information
-             IF ( check_existence( var_names, 'pavement_pars' ) )  THEN
-                pavement_pars_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    pavement_pars_f%fill,                      &
-                                    .FALSE., 'pavement_pars' )
-!
-!--             Inquire number of pavement parameters
-                CALL get_dimension_length( id_surf, pavement_pars_f%np,        &
-                                           'npavement_pars' )
-!
-!--             Allocate dimension array and input array for pavement parameters
-                ALLOCATE( pavement_pars_f%pars(0:pavement_pars_f%np-1) )
-                ALLOCATE( pavement_pars_f%pars_xy(0:pavement_pars_f%np-1,      &
-                                                  nys:nyn,nxl:nxr) )
-!
-!--             Get dimension of pavement parameters
-                CALL get_variable( id_surf, 'npavement_pars',                  &
-                                   pavement_pars_f%pars )
-
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      CALL get_variable( id_surf, 'pavement_pars', i, j,       &
-                                         pavement_pars_f%pars_xy(:,j,i) )
-                   ENDDO
-                ENDDO
-             ELSE
-                pavement_pars_f%from_file = .FALSE.
-             ENDIF
-
-!
-!--          Read pavement subsurface parameters and related information
-             IF ( check_existence( var_names, 'pavement_subsurface_pars' ) )   &
-             THEN
-                pavement_subsurface_pars_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    pavement_subsurface_pars_f%fill,           &
-                                    .FALSE., 'pavement_subsurface_pars' )
-!
-!--             Inquire number of parameters
-                CALL get_dimension_length( id_surf,                            &
-                                           pavement_subsurface_pars_f%np,      &
-                                           'npavement_subsurface_pars' )
-!
-!--             Inquire number of soil layers
-                CALL get_dimension_length( id_surf,                            &
-                                           pavement_subsurface_pars_f%nz,      &
-                                           'zsoil' )
-!
-!--             Allocate dimension array and input array for pavement parameters
-                ALLOCATE( pavement_subsurface_pars_f%pars                      &
-                                  (0:pavement_subsurface_pars_f%np-1) )
-                ALLOCATE( pavement_subsurface_pars_f%pars_xyz                  &
-                                  (0:pavement_subsurface_pars_f%np-1,          &
-                                   0:pavement_subsurface_pars_f%nz-1,          &
-                                   nys:nyn,nxl:nxr) )
-!
-!--             Get dimension of pavement parameters
-                CALL get_variable( id_surf, 'npavement_subsurface_pars',       &
-                                   pavement_subsurface_pars_f%pars )
-
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      CALL get_variable(                                       &
-                                  id_surf, 'pavement_subsurface_pars',         &
-                                  i, j,                                        &
-                                  pavement_subsurface_pars_f%pars_xyz(:,:,j,i),&
-                                  pavement_subsurface_pars_f%nz,               &
-                                  pavement_subsurface_pars_f%np )
-                   ENDDO
-                ENDDO
-             ELSE
-                pavement_subsurface_pars_f%from_file = .FALSE.
-             ENDIF
-
-
-!
-!--          Read vegetation parameters and related information
-             IF ( check_existence( var_names, 'vegetation_pars' ) )  THEN
-                vegetation_pars_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    vegetation_pars_f%fill,                    &
-                                    .FALSE.,  'vegetation_pars' )
-!
-!--             Inquire number of vegetation parameters
-                CALL get_dimension_length( id_surf, vegetation_pars_f%np,      &
-                                           'nvegetation_pars' )
-!
-!--             Allocate dimension array and input array for surface fractions
-                ALLOCATE( vegetation_pars_f%pars(0:vegetation_pars_f%np-1) )
-                ALLOCATE( vegetation_pars_f%pars_xy(0:vegetation_pars_f%np-1,  &
-                                                    nys:nyn,nxl:nxr) )
-!
-!--             Get dimension of the parameters
-                CALL get_variable( id_surf, 'nvegetation_pars',                &
-                                   vegetation_pars_f%pars )
-
-                CALL get_variable( id_surf, 'vegetation_pars',                 &
-                                   nxl, nxr, nys, nyn,                         &
-                                   vegetation_pars_f%pars_xy(:,nys:nyn,nxl:nxr ) )
-             ELSE
-                vegetation_pars_f%from_file = .FALSE.
-             ENDIF
-
-!
-!--          Read root parameters/distribution and related information
-             IF ( check_existence( var_names, 'soil_pars' ) )  THEN
-                soil_pars_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    soil_pars_f%fill,                          &
-                                    .FALSE., 'soil_pars' )
-
-                CALL get_attribute( id_surf, char_lod,                         &
-                                    soil_pars_f%lod,                           &
-                                    .FALSE., 'soil_pars' )
-
-!
-!--             Inquire number of soil parameters
-                CALL get_dimension_length( id_surf,                            &
-                                           soil_pars_f%np,                     &
-                                           'nsoil_pars' )
-!
-!--             Read parameters array
-                ALLOCATE( soil_pars_f%pars(0:soil_pars_f%np-1) )
-                CALL get_variable( id_surf, 'nsoil_pars', soil_pars_f%pars )
-
-!
-!--             In case of level of detail 2, also inquire number of vertical
-!--             soil layers, allocate memory and read the respective dimension
-                IF ( soil_pars_f%lod == 2 )  THEN
-                   CALL get_dimension_length( id_surf, soil_pars_f%nz, 'zsoil' )
-
-                   ALLOCATE( soil_pars_f%layers(0:soil_pars_f%nz-1) )
-                   CALL get_variable( id_surf, 'zsoil', soil_pars_f%layers )
-
-                ENDIF
-
-!
-!--             Read soil parameters, depending on level of detail
-                IF ( soil_pars_f%lod == 1 )  THEN
-                   ALLOCATE( soil_pars_f%pars_xy(0:soil_pars_f%np-1,           &
-                                                 nys:nyn,nxl:nxr) )
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         CALL get_variable( id_surf, 'soil_pars', i, j,        &
-                                            soil_pars_f%pars_xy(:,j,i) )
-                      ENDDO
-                   ENDDO
-
-                ELSEIF ( soil_pars_f%lod == 2 )  THEN
-                   ALLOCATE( soil_pars_f%pars_xyz(0:soil_pars_f%np-1,          &
-                                                  0:soil_pars_f%nz-1,          &
-                                                  nys:nyn,nxl:nxr) )
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         CALL get_variable( id_surf, 'soil_pars', i, j,        &
-                                            soil_pars_f%pars_xyz(:,:,j,i),     &
-                                            soil_pars_f%nz, soil_pars_f%np )
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ELSE
-                soil_pars_f%from_file = .FALSE.
-             ENDIF
-
-!
-!--          Read water parameters and related information
-             IF ( check_existence( var_names, 'water_pars' ) )  THEN
-                water_pars_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    water_pars_f%fill,                         &
-                                    .FALSE., 'water_pars' )
-!
-!--             Inquire number of water parameters
-                CALL get_dimension_length( id_surf,                            &
-                                           water_pars_f%np,                    &
-                                           'nwater_pars' )
-!
-!--             Allocate dimension array and input array for water parameters
-                ALLOCATE( water_pars_f%pars(0:water_pars_f%np-1) )
-                ALLOCATE( water_pars_f%pars_xy(0:water_pars_f%np-1,            &
-                                               nys:nyn,nxl:nxr) )
-!
-!--             Get dimension of water parameters
-                CALL get_variable( id_surf, 'nwater_pars', water_pars_f%pars )
-
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      CALL get_variable( id_surf, 'water_pars', i, j,          &
-                                         water_pars_f%pars_xy(:,j,i) )
-                   ENDDO
-                ENDDO
-             ELSE
-                water_pars_f%from_file = .FALSE.
-             ENDIF
-!
-!--          Read root area density - parametrized vegetation
-             IF ( check_existence( var_names, 'root_area_dens_s' ) )  THEN
-                root_area_density_lsm_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    root_area_density_lsm_f%fill,              &
-                                    .FALSE., 'root_area_dens_s' )
-!
-!--             Obtain number of soil layers from file and allocate variable
-                CALL get_dimension_length( id_surf, root_area_density_lsm_f%nz,&
-                                           'zsoil' )
-                ALLOCATE( root_area_density_lsm_f%var                          &
-                                              (0:root_area_density_lsm_f%nz-1, &
-                                               nys:nyn,nxl:nxr) )
-
-!
-!--             Read root-area density
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      CALL get_variable( id_surf, 'root_area_dens_s',          &
-                                         i, j,                                 &
-                                         root_area_density_lsm_f%var(:,j,i) )
-                   ENDDO
-                ENDDO
-
-             ELSE
-                root_area_density_lsm_f%from_file = .FALSE.
-             ENDIF
-!
-!--          Read street type and street crossing
-             IF ( check_existence( var_names, 'street_type' ) )  THEN
-                street_type_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    street_type_f%fill, .FALSE.,               &
-                                    'street_type' )
-!
-!--             PE-wise reading of 2D pavement type.
-                ALLOCATE ( street_type_f%var(nys:nyn,nxl:nxr)  )
-                DO  i = nxl, nxr
-                   CALL get_variable( id_surf, 'street_type',                  &
-                                      i, street_type_f%var(:,i) )
-                ENDDO
-             ELSE
-                street_type_f%from_file = .FALSE.
-             ENDIF
-
-             IF ( check_existence( var_names, 'street_crossing' ) )  THEN
-                street_crossing_f%from_file = .TRUE.
-                CALL get_attribute( id_surf, char_fill,                        &
-                                    street_crossing_f%fill, .FALSE.,           &
-                                    'street_crossing' )
-!
-!--             PE-wise reading of 2D pavement type.
-                ALLOCATE ( street_crossing_f%var(nys:nyn,nxl:nxr)  )
-                DO  i = nxl, nxr
-                   CALL get_variable( id_surf, 'street_crossing',              &
-                                      i, street_crossing_f%var(:,i) )
-                ENDDO
-             ELSE
-                street_crossing_f%from_file = .FALSE.
-             ENDIF
-!
-!--          Still missing: root_resolved and building_surface_pars.
-!--          Will be implemented as soon as they are available.
-
-!
-!--          Finally, close input file
-             CALL close_input_file( id_surf )
+!--    Open file in read-only mode
+       CALL open_read_file( TRIM( input_file_static ) //                       &
+                            TRIM( coupling_char ) , id_surf )
+!
+!--    Inquire all variable names.
+!--    This will be used to check whether an optional input variable exist
+!--    or not.
+       CALL inquire_num_variables( id_surf, num_vars )
+
+       ALLOCATE( var_names(1:num_vars) )
+       CALL inquire_variable_names( id_surf, var_names )
+!
+!--    Read vegetation type and required attributes
+       IF ( check_existence( var_names, 'vegetation_type' ) )  THEN
+          vegetation_type_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              vegetation_type_f%fill,                          &
+                              .FALSE., 'vegetation_type' )
+
+          ALLOCATE ( vegetation_type_f%var(nys:nyn,nxl:nxr)  )
+
+          CALL get_variable( id_surf, 'vegetation_type',                       &
+                             vegetation_type_f%var, nxl, nxr, nys, nyn )
+       ELSE
+          vegetation_type_f%from_file = .FALSE.
+       ENDIF
+
+!
+!--    Read soil type and required attributes
+       IF ( check_existence( var_names, 'soil_type' ) )  THEN
+             soil_type_f%from_file = .TRUE.
+!
+!--       Note, lod is currently not on file; skip for the moment
+!           CALL get_attribute( id_surf, char_lod,                       &
+!                                      soil_type_f%lod,                  &
+!                                      .FALSE., 'soil_type' )
+          CALL get_attribute( id_surf, char_fill,                              &
+                              soil_type_f%fill,                                &
+                              .FALSE., 'soil_type' )
+
+          IF ( soil_type_f%lod == 1 )  THEN
+
+             ALLOCATE ( soil_type_f%var_2d(nys:nyn,nxl:nxr)  )
+
+             CALL get_variable( id_surf, 'soil_type', soil_type_f%var_2d,      &
+                                nxl, nxr, nys, nyn )
+
+          ELSEIF ( soil_type_f%lod == 2 )  THEN
+!
+!--          Obtain number of soil layers from file.
+             CALL get_dimension_length( id_surf, nz_soil, 'zsoil' )
+
+             ALLOCATE ( soil_type_f%var_3d(0:nz_soil,nys:nyn,nxl:nxr) )
+
+             CALL get_variable( id_surf, 'soil_type', soil_type_f%var_3d,      &
+                                nxl, nxr, nys, nyn, 0, nz_soil )
+ 
+          ENDIF
+       ELSE
+          soil_type_f%from_file = .FALSE.
+       ENDIF
+
+!
+!--    Read pavement type and required attributes
+       IF ( check_existence( var_names, 'pavement_type' ) )  THEN
+          pavement_type_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              pavement_type_f%fill, .FALSE.,                   &
+                              'pavement_type' )
+
+          ALLOCATE ( pavement_type_f%var(nys:nyn,nxl:nxr)  )
+
+          CALL get_variable( id_surf, 'pavement_type', pavement_type_f%var,    &
+                             nxl, nxr, nys, nyn )
+       ELSE
+          pavement_type_f%from_file = .FALSE.
+       ENDIF
+
+!
+!--    Read water type and required attributes
+       IF ( check_existence( var_names, 'water_type' ) )  THEN
+          water_type_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill, water_type_f%fill,           &
+                              .FALSE., 'water_type' )
+
+          ALLOCATE ( water_type_f%var(nys:nyn,nxl:nxr)  )
+
+          CALL get_variable( id_surf, 'water_type', water_type_f%var,          &
+                             nxl, nxr, nys, nyn )
+
+       ELSE
+          water_type_f%from_file = .FALSE.
+       ENDIF
+!
+!--    Read surface fractions and related information
+       IF ( check_existence( var_names, 'surface_fraction' ) )  THEN
+          surface_fraction_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              surface_fraction_f%fill,                         &
+                              .FALSE., 'surface_fraction' )
+!
+!--       Inquire number of surface fractions
+          CALL get_dimension_length( id_surf,                                  &
+                                     surface_fraction_f%nf,                    &
+                                     'nsurface_fraction' )
+!
+!--       Allocate dimension array and input array for surface fractions
+          ALLOCATE( surface_fraction_f%nfracs(0:surface_fraction_f%nf-1) )
+          ALLOCATE( surface_fraction_f%frac(0:surface_fraction_f%nf-1,         &
+                                            nys:nyn,nxl:nxr) )
+!
+!--       Get dimension of surface fractions
+          CALL get_variable( id_surf, 'nsurface_fraction',                     &
+                             surface_fraction_f%nfracs )
+!
+!--       Read surface fractions
+          CALL get_variable( id_surf, 'surface_fraction',                      &
+                             surface_fraction_f%frac, nxl, nxr, nys, nyn,      &
+                             0, surface_fraction_f%nf-1 )
+       ELSE
+          surface_fraction_f%from_file = .FALSE.
+       ENDIF
+!
+!--    Read building parameters and related information
+       IF ( check_existence( var_names, 'building_pars' ) )  THEN
+          building_pars_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              building_pars_f%fill,                            &
+                              .FALSE., 'building_pars' )
+!
+!--       Inquire number of building parameters
+          CALL get_dimension_length( id_surf,                                  &
+                                     building_pars_f%np,                       &
+                                     'nbuilding_pars' )
+!
+!--       Allocate dimension array and input array for building parameters
+          ALLOCATE( building_pars_f%pars(0:building_pars_f%np-1) )
+          ALLOCATE( building_pars_f%pars_xy(0:building_pars_f%np-1,            &
+                                            nys:nyn,nxl:nxr) )
+!
+!--       Get dimension of building parameters
+          CALL get_variable( id_surf, 'nbuilding_pars',                        &
+                             building_pars_f%pars )
+!
+!--       Read building_pars
+          CALL get_variable( id_surf, 'building_pars',                         &
+                             building_pars_f%pars_xy, nxl, nxr, nys, nyn,      &
+                             0, building_pars_f%np-1 )
+       ELSE
+          building_pars_f%from_file = .FALSE.
+       ENDIF
+
+!
+!--    Read albedo type and required attributes
+       IF ( check_existence( var_names, 'albedo_type' ) )  THEN
+          albedo_type_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill, albedo_type_f%fill,          &
+                              .FALSE.,  'albedo_type' )
+
+          ALLOCATE ( albedo_type_f%var(nys:nyn,nxl:nxr)  )
+          
+          CALL get_variable( id_surf, 'albedo_type', albedo_type_f%var,        &
+                             nxl, nxr, nys, nyn )
+       ELSE
+          albedo_type_f%from_file = .FALSE.
+       ENDIF
+!
+!--    Read albedo parameters and related information
+       IF ( check_existence( var_names, 'albedo_pars' ) )  THEN
+          albedo_pars_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill, albedo_pars_f%fill,          &
+                              .FALSE., 'albedo_pars' )
+!
+!--       Inquire number of albedo parameters
+          CALL get_dimension_length( id_surf, albedo_pars_f%np,                &
+                                     'nalbedo_pars' )
+!
+!--       Allocate dimension array and input array for albedo parameters
+          ALLOCATE( albedo_pars_f%pars(0:albedo_pars_f%np-1) )
+          ALLOCATE( albedo_pars_f%pars_xy(0:albedo_pars_f%np-1,                &
+                                          nys:nyn,nxl:nxr) )
+!
+!--       Get dimension of albedo parameters
+          CALL get_variable( id_surf, 'nalbedo_pars', albedo_pars_f%pars )
+
+          CALL get_variable( id_surf, 'albedo_pars', albedo_pars_f%pars_xy,    &
+                             nxl, nxr, nys, nyn,                               &
+                             0, albedo_pars_f%np-1 )
+       ELSE
+          albedo_pars_f%from_file = .FALSE.
+       ENDIF
+
+!
+!--    Read pavement parameters and related information
+       IF ( check_existence( var_names, 'pavement_pars' ) )  THEN
+          pavement_pars_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              pavement_pars_f%fill,                            &
+                              .FALSE., 'pavement_pars' )
+!
+!--       Inquire number of pavement parameters
+          CALL get_dimension_length( id_surf, pavement_pars_f%np,              &
+                                     'npavement_pars' )
+!
+!--       Allocate dimension array and input array for pavement parameters
+          ALLOCATE( pavement_pars_f%pars(0:pavement_pars_f%np-1) )
+          ALLOCATE( pavement_pars_f%pars_xy(0:pavement_pars_f%np-1,            &
+                                            nys:nyn,nxl:nxr) )
+!
+!--       Get dimension of pavement parameters
+          CALL get_variable( id_surf, 'npavement_pars', pavement_pars_f%pars )
+
+          CALL get_variable( id_surf, 'pavement_pars', pavement_pars_f%pars_xy,&
+                             nxl, nxr, nys, nyn,                               &
+                             0, pavement_pars_f%np-1 )
+       ELSE
+          pavement_pars_f%from_file = .FALSE.
+       ENDIF
+
+!
+!--    Read pavement subsurface parameters and related information
+       IF ( check_existence( var_names, 'pavement_subsurface_pars' ) )         &
+       THEN
+          pavement_subsurface_pars_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              pavement_subsurface_pars_f%fill,                 &
+                              .FALSE., 'pavement_subsurface_pars' )
+!
+!--       Inquire number of parameters
+          CALL get_dimension_length( id_surf,                                  &
+                                     pavement_subsurface_pars_f%np,            &
+                                     'npavement_subsurface_pars' )
+!
+!--       Inquire number of soil layers
+          CALL get_dimension_length( id_surf,                                  &
+                                     pavement_subsurface_pars_f%nz,            &
+                                     'zsoil' )
+!
+!--       Allocate dimension array and input array for pavement parameters
+          ALLOCATE( pavement_subsurface_pars_f%pars                            &
+                            (0:pavement_subsurface_pars_f%np-1) )
+          ALLOCATE( pavement_subsurface_pars_f%pars_xyz                        &
+                            (0:pavement_subsurface_pars_f%np-1,                &
+                             0:pavement_subsurface_pars_f%nz-1,                &
+                             nys:nyn,nxl:nxr) )
+!
+!--       Get dimension of pavement parameters
+          CALL get_variable( id_surf, 'npavement_subsurface_pars',             &
+                             pavement_subsurface_pars_f%pars )
+
+          CALL get_variable( id_surf, 'pavement_subsurface_pars',              &
+                             pavement_subsurface_pars_f%pars_xyz,              &
+                             nxl, nxr, nys, nyn,                               &
+                             0, pavement_subsurface_pars_f%nz-1,               &
+                             0, pavement_subsurface_pars_f%np-1 )
+       ELSE
+          pavement_subsurface_pars_f%from_file = .FALSE.
+       ENDIF
+
+
+!
+!--    Read vegetation parameters and related information
+       IF ( check_existence( var_names, 'vegetation_pars' ) )  THEN
+          vegetation_pars_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              vegetation_pars_f%fill,                          &
+                              .FALSE.,  'vegetation_pars' )
+!
+!--       Inquire number of vegetation parameters
+          CALL get_dimension_length( id_surf, vegetation_pars_f%np,            &
+                                     'nvegetation_pars' )
+!
+!--       Allocate dimension array and input array for surface fractions
+          ALLOCATE( vegetation_pars_f%pars(0:vegetation_pars_f%np-1) )
+          ALLOCATE( vegetation_pars_f%pars_xy(0:vegetation_pars_f%np-1,        &
+                                              nys:nyn,nxl:nxr) )
+!
+!--       Get dimension of the parameters
+          CALL get_variable( id_surf, 'nvegetation_pars',                      &
+                             vegetation_pars_f%pars )
+
+          CALL get_variable( id_surf, 'vegetation_pars',                       &
+                             vegetation_pars_f%pars_xy, nxl, nxr, nys, nyn,    &
+                             0, vegetation_pars_f%np-1 )
+       ELSE
+          vegetation_pars_f%from_file = .FALSE.
+       ENDIF
+
+!
+!--    Read root parameters/distribution and related information
+       IF ( check_existence( var_names, 'soil_pars' ) )  THEN
+          soil_pars_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              soil_pars_f%fill,                                &
+                              .FALSE., 'soil_pars' )
+
+          CALL get_attribute( id_surf, char_lod,                               &
+                              soil_pars_f%lod,                                 &
+                              .FALSE., 'soil_pars' )
+
+!
+!--       Inquire number of soil parameters
+          CALL get_dimension_length( id_surf,                                  &
+                                     soil_pars_f%np,                           &
+                                     'nsoil_pars' )
+!
+!--       Read parameters array
+          ALLOCATE( soil_pars_f%pars(0:soil_pars_f%np-1) )
+          CALL get_variable( id_surf, 'nsoil_pars', soil_pars_f%pars )
+
+!
+!--       In case of level of detail 2, also inquire number of vertical
+!--       soil layers, allocate memory and read the respective dimension
+          IF ( soil_pars_f%lod == 2 )  THEN
+             CALL get_dimension_length( id_surf, soil_pars_f%nz, 'zsoil' )
+
+             ALLOCATE( soil_pars_f%layers(0:soil_pars_f%nz-1) )
+             CALL get_variable( id_surf, 'zsoil', soil_pars_f%layers )
+
+          ENDIF
+
+!
+!--       Read soil parameters, depending on level of detail
+          IF ( soil_pars_f%lod == 1 )  THEN
+             ALLOCATE( soil_pars_f%pars_xy(0:soil_pars_f%np-1,                 &
+                                           nys:nyn,nxl:nxr) )
+                  
+             CALL get_variable( id_surf, 'soil_pars', soil_pars_f%pars_xy,     &
+                                nxl, nxr, nys, nyn, 0, soil_pars_f%np-1 )
+
+          ELSEIF ( soil_pars_f%lod == 2 )  THEN
+             ALLOCATE( soil_pars_f%pars_xyz(0:soil_pars_f%np-1,                &
+                                            0:soil_pars_f%nz-1,                &
+                                            nys:nyn,nxl:nxr) )
+             CALL get_variable( id_surf, 'soil_pars',                          &
+                                soil_pars_f%pars_xyz,                          &
+                                nxl, nxr, nys, nyn, 0, soil_pars_f%nz-1,       &
+                                0, soil_pars_f%np-1 )
+
+          ENDIF
+       ELSE
+          soil_pars_f%from_file = .FALSE.
+       ENDIF
+
+!
+!--    Read water parameters and related information
+       IF ( check_existence( var_names, 'water_pars' ) )  THEN
+          water_pars_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              water_pars_f%fill,                               &
+                              .FALSE., 'water_pars' )
+!
+!--       Inquire number of water parameters
+          CALL get_dimension_length( id_surf,                                  &
+                                     water_pars_f%np,                          &
+                                     'nwater_pars' )
+!
+!--       Allocate dimension array and input array for water parameters
+          ALLOCATE( water_pars_f%pars(0:water_pars_f%np-1) )
+          ALLOCATE( water_pars_f%pars_xy(0:water_pars_f%np-1,                  &
+                                         nys:nyn,nxl:nxr) )
+!
+!--       Get dimension of water parameters
+          CALL get_variable( id_surf, 'nwater_pars', water_pars_f%pars )
+
+          CALL get_variable( id_surf, 'water_pars', water_pars_f%pars_xy,      &
+                             nxl, nxr, nys, nyn, 0, water_pars_f%np-1 )
+       ELSE
+          water_pars_f%from_file = .FALSE.
+       ENDIF
+!
+!--    Read root area density - parametrized vegetation
+       IF ( check_existence( var_names, 'root_area_dens_s' ) )  THEN
+          root_area_density_lsm_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              root_area_density_lsm_f%fill,                    &
+                              .FALSE., 'root_area_dens_s' )
+!
+!--       Obtain number of soil layers from file and allocate variable
+          CALL get_dimension_length( id_surf, root_area_density_lsm_f%nz,      &
+                                     'zsoil' )
+          ALLOCATE( root_area_density_lsm_f%var                                &
+                                        (0:root_area_density_lsm_f%nz-1,       &
+                                         nys:nyn,nxl:nxr) )
+
+!
+!--       Read root-area density
+          CALL get_variable( id_surf, 'root_area_dens_s',                      &
+                             root_area_density_lsm_f%var,                      &
+                             nxl, nxr, nys, nyn,                               &
+                             0, root_area_density_lsm_f%nz-1 )
+
+       ELSE
+          root_area_density_lsm_f%from_file = .FALSE.
+       ENDIF
+!
+!--    Read street type and street crossing
+       IF ( check_existence( var_names, 'street_type' ) )  THEN
+          street_type_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              street_type_f%fill, .FALSE.,                     &
+                              'street_type' )
+
+          ALLOCATE ( street_type_f%var(nys:nyn,nxl:nxr)  )
+          
+          CALL get_variable( id_surf, 'street_type', street_type_f%var,        &
+                             nxl, nxr, nys, nyn )
+       ELSE
+          street_type_f%from_file = .FALSE.
+       ENDIF
+
+       IF ( check_existence( var_names, 'street_crossing' ) )  THEN
+          street_crossing_f%from_file = .TRUE.
+          CALL get_attribute( id_surf, char_fill,                              &
+                              street_crossing_f%fill, .FALSE.,                 &
+                              'street_crossing' )
+
+          ALLOCATE ( street_crossing_f%var(nys:nyn,nxl:nxr)  )
+
+          CALL get_variable( id_surf, 'street_crossing',                       &
+                             street_crossing_f%var, nxl, nxr, nys, nyn )
+
+       ELSE
+          street_crossing_f%from_file = .FALSE.
+       ENDIF
+!
+!--    Still missing: root_resolved and building_surface_pars.
+!--    Will be implemented as soon as they are available.
+
+!
+!--    Finally, close input file
+       CALL close_input_file( id_surf )
 #endif
-          ENDIF
-#if defined( __parallel )
-          CALL MPI_BARRIER( comm2d, ierr )
-#endif
-       ENDDO
 !
 !--    End of CPU measurement
